Skip to content
Back to top
View this page
Edit this page

# superduper.gateway

The gateway

## Classes

`Gateway` | This is instantiated once by the slidge entrypoint.

## Module Contents

class superduper.gateway.Gateway

  This is instantiated once by the slidge entrypoint.

  By customizing the class attributes, we customize the registration process, and display name of the component.

  COMPONENT_NAME = 'The great legacy network (slidge)'

    Name of the component, as seen in service discovery by XMPP clients

  COMPONENT_AVATAR

    Path, bytes or URL used by the component as an avatar.

  COMPONENT_TYPE = 'whatsapp'

    Type of the gateway, should follow https://xmpp.org/registrar/disco-categories.html

  REGISTRATION_INSTRUCTIONS = "Register to this fake service by using 'slidger' as username, and any password you want. Then...

    The text presented to a user that wants to register (or modify) their legacy account configuration.

  REGISTRATION_TYPE

    This attribute determines how users register to the gateway, ie, how they login to the legacy service. The credentials are then stored persistently, so this process should happen once per user (unless they unregister).

    The registration process always start with a basic data form (XEP-0004) presented to the user. But the legacy login flow might require something more sophisticated, see `RegistrationType` for more details.

  REGISTRATION_FIELDS

    Iterable of fields presented to the gateway user when registering using XEP-0077 extended by XEP-0004.

  MARK_ALL_MESSAGES = True

    Set this to True for legacy networks that expects read marks for all messages and not just the latest one that was read (as most XMPP clients will only send a read mark for the latest msg).

  LEGACY_CONTACT_ID_TYPE

    Modify this if the legacy network uses unique contact IDs that are not strings.

    This is required because we store those IDs as TEXT in the persistent SQL DB. The callable specified here is responsible for converting the serialised-as-text version of the contact unique ID back to the proper type. Common example: `int`.

  async validate(user_jid, registration_form)

    This function receives the values of the form defined in `REGISTRATION_FIELDS`. Here, since we set `REGISTRATION_TYPE` to “2FA”, if this method does not raise any exception, the wannabe user will be prompted for their 2FA code.

    Parameters:

      - user_jid (slixmpp.JID)

      - registration_form (dict[str, Optional[str]])

    Returns:

  async validate_two_factor_code(user, code)

    This function receives the 2FA code entered by the aspiring user.

    It should raise something if the 2FA does not permit logging in to the legacy service.

    Parameters:

      - user (slidge.GatewayUser)

      - code (str)

  ROSTER_GROUP: str = 'slidge'

    Name of the group assigned to a `LegacyContact` automagically added to the User’s roster with `LegacyContact.add_to_roster()`.

  WELCOME_MESSAGE = "Thank you for registering. Type 'help' to list the available commands, or just start messaging away!"

    A welcome message displayed to users on registration. This is useful notably for clients that don’t consider component JIDs as a valid recipient in their UI, yet still open a functional chat window on incoming messages from components.

  SEARCH_FIELDS: Sequence[slidge.command.base.FormField]

    Fields used for searching items via the component, through XEP-0055 (jabber search). A common use case is to allow users to search for legacy contacts by something else than their usernames, eg their phone number.

    Plugins should implement search by overriding `BaseSession.search()` (restricted to registered users).

    If there is only one field, it can also be used via the `jabber:iq:gateway` protocol described in XEP-0100. Limitation: this only works if the search request returns one result item, and if this item has a ‘jid’ var.

  SEARCH_TITLE: str = 'Search for legacy contacts'

    Title of the search form.

  SEARCH_INSTRUCTIONS: str = ''

    Instructions of the search form.

  PROPER_RECEIPTS = False

    Set this to True if the legacy service provides a real equivalent of message delivery receipts (XEP-0184), meaning that there is an event thrown when the actual device of a contact receives a message. Make sure to call Contact.received() adequately if this is set to True.

  AVATAR_ID_TYPE: Callable[[str], Any]

    Modify this if the legacy network uses unique avatar IDs that are not strings.

    This is required because we store those IDs as TEXT in the persistent SQL DB. The callable specified here will receive is responsible for converting the serialised-as-text version of the avatar unique ID back to the proper type. Common example: `int`.

  LEGACY_MSG_ID_TYPE: Callable[[str], Any]

    Modify this if the legacy network uses unique message IDs that are not strings.

    This is required because we store those IDs as TEXT in the persistent SQL DB. The callable specified here will receive is responsible for converting the serialised-as-text version of the message unique ID back to the proper type. Common example: `int`.

  LEGACY_ROOM_ID_TYPE: Callable[[str], Any]

    Modify this if the legacy network uses unique room IDs that are not strings.

    This is required because we store those IDs as TEXT in the persistent SQL DB. The callable specified here is responsible for converting the serialised-as-text version of the room unique ID back to the proper type. Common example: `int`.

  DB_POOL_SIZE: int = 5

    Size of the queue pool for sqlalchemy engine. Typically, when using python async libraries, this does not need to be changed. Change that if your gateway use separate threads to call into slidge. The value of this parameter should be equal or greater than the potential number of threads.

  abstractmethod get_qr_text(user)
    Async:

    Parameters:

      user (slidge.db.GatewayUser)

    Return type:

      str

    This is where slidge gets the QR code content for the QR-based registration process. It will turn it into a QR code image and send it to the not-yet-fully-registered `GatewayUser`.

    Only used in when `BaseGateway.REGISTRATION_TYPE` is `RegistrationType.QRCODE`.

    Parameters:

      user (slidge.db.GatewayUser) – The `GatewayUser` whose registration is pending Use their `GatewayUser.bare_jid` and/or `registration_form` attributes to get what you need.

    Return type:

      str

  async confirm_qr(user_bare_jid, exception=None, legacy_data=None)

    This method is meant to be called to finalize QR code-based registration flows, once the legacy service confirms the QR flashing.

    Only used in when `BaseGateway.REGISTRATION_TYPE` is `RegistrationType.QRCODE`.

    Parameters:

      - user_bare_jid (str) – The bare JID of the almost-registered `GatewayUser` instance

      - exception (Optional[Exception]) – Optionally, an XMPPError to be raised to not confirm QR code flashing.

      - legacy_data (Optional[slidge.db.meta.JSONSerializable]) – dict which keys and values will be added to the persistent “legacy_module_data” for this user.

    Return type:

      None

  async unregister(session)

    Optionally override this if you need to clean additional stuff after a user has been removed from the persistent user store.

    By default, this just calls `BaseSession.logout()`.

    Parameters:

      session (slidge.core.session.BaseSession) – The session of the user who just unregistered

    Return type:

      None

  async input(jid, text=None, mtype='chat', **input_kwargs)

    Request arbitrary user input using a simple chat message, and await the result.

    You shouldn’t need to call this directly bust instead use `BaseSession.input()` to directly target a user.

    Parameters:

      - jid (slixmpp.JID) – The JID we want input from

      - text (str | None) – A prompt to display for the user

      - mtype (slixmpp.types.MessageTypes) – Message type

      - input_kwargs (Any)

    Returns:

      The user’s reply

    Return type:

      str

  async send_qr(text, **msg_kwargs)

    Sends a QR Code to a JID

    You shouldn’t need to call directly bust instead use `BaseSession.send_qr()` to directly target a user.

    Parameters:

      - text (str) – The text that will be converted to a QR Code

      - msg_kwargs (Any) – Optional additional arguments to pass to `BaseGateway.send_file()`, such as the recipient of the QR, code

    Return type:

      None

  invite_to(muc, reason=None, password=None, **send_kwargs)

    Send an invitation to join a group (XEP-0249) from this XMPP Entity.

    Parameters:

      - muc (slidge.group.LegacyMUC) – the muc the user is invited to

      - reason (Optional[str]) – a text explaining why the user should join this muc

      - password (Optional[str]) – maybe this will make sense later? not sure

      - send_kwargs – additional kwargs to be passed to _send() (internal use by slidge)

    Return type:

      None

  active(**kwargs)

    Send an “active” chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  composing(**kwargs)

    Send a “composing” (ie “typing notification”) chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  paused(**kwargs)

    Send a “paused” (ie “typing paused notification”) chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  inactive(**kwargs)

    Send an “inactive” (ie “contact has not interacted with the chat session interface for an intermediate period of time”) chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  gone(**kwargs)

    Send a “gone” (ie “contact has not interacted with the chat session interface, system, or device for a relatively long period of time”) chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  ack(legacy_msg_id, **kwargs)

    Send an “acknowledged” message marker (XEP-0333) from this XMPP Entity.

    Parameters:

      legacy_msg_id (slidge.util.types.LegacyMessageType) – The message this marker refers to

    Return type:

      None

  received(legacy_msg_id, **kwargs)

    Send a “received” message marker (XEP-0333) from this XMPP Entity. If called on a `LegacyContact`, also send a delivery receipt marker (XEP-0184).

    Parameters:

      legacy_msg_id (slidge.util.types.LegacyMessageType) – The message this marker refers to

    Return type:

      None

  displayed(legacy_msg_id, **kwargs)

    Send a “displayed” message marker (XEP-0333) from this XMPP Entity.

    Parameters:

      legacy_msg_id (slidge.util.types.LegacyMessageType) – The message this marker refers to

    Return type:

      None

  async send_file(attachment, legacy_msg_id=None, *, reply_to=None, when=None, thread=None, **kwargs)

    Send a single file from this XMPP Entity.

    Parameters:

      - attachment (slidge.util.types.LegacyAttachment | pathlib.Path | str) – The file to send. Ideally, a `LegacyAttachment` with a unique `legacy_file_id` attribute set, to optimise potential future reuses. It can also be: - a `pathlib.Path` instance to point to a local file, or - a `str`, representing a fetchable HTTP URL.

      - legacy_msg_id (Optional[slidge.util.types.LegacyMessageType]) – If you want to be able to transport read markers from the gateway user to the legacy network, specify this

      - reply_to (Optional[slidge.util.types.MessageReference]) – Quote another message (XEP-0461)

      - when (Optional[datetime.datetime]) – when the file was sent, for a “delay” tag (XEP-0203)

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Return type:

      tuple[Optional[str], list[slixmpp.Message]]

  send_text(body, legacy_msg_id=None, *, when=None, reply_to=None, thread=None, hints=None, carbon=False, archive_only=False, correction=False, correction_event_id=None, link_previews=None, **send_kwargs)

    Send a text message from this XMPP Entity.

    Parameters:

      - body (str) – Content of the message

      - legacy_msg_id (Optional[slidge.util.types.LegacyMessageType]) – If you want to be able to transport read markers from the gateway user to the legacy network, specify this

      - when (Optional[datetime.datetime]) – when the message was sent, for a “delay” tag (XEP-0203)

      - reply_to (Optional[slidge.util.types.MessageReference]) – Quote another message (XEP-0461)

      - hints (Optional[Iterable[slidge.util.types.ProcessingHint]])

      - thread (Optional[slidge.util.types.LegacyThreadType])

      - carbon (bool) – (only used if called on a `LegacyContact`) Set this to `True` if this is actually a message sent to the `LegacyContact` by the User. Use this to synchronize outgoing history for legacy official apps.

      - correction (bool) – whether this message is a correction or not

      - correction_event_id (Optional[slidge.util.types.LegacyMessageType]) – in the case where an ID is associated with the legacy ‘correction event’, specify it here to use it on the XMPP side. If not specified, a random ID will be used.

      - link_previews (Optional[list[slidge.util.types.LinkPreview]]) – A little of sender (or server, or gateway)-generated previews of URLs linked in the body.

      - archive_only (bool) – (only in groups) Do not send this message to user, but store it in the archive. Meant to be used during `MUC.backfill()`

  correct(legacy_msg_id, new_text, *, when=None, reply_to=None, thread=None, hints=None, carbon=False, archive_only=False, correction_event_id=None, link_previews=None, **send_kwargs)

    Modify a message that was previously sent by this XMPP Entity.

    Uses last message correction (XEP-0308)

    Parameters:

      - new_text (str) – New content of the message

      - legacy_msg_id (slidge.util.types.LegacyMessageType) – The legacy message ID of the message to correct

      - when (Optional[datetime.datetime]) – when the message was sent, for a “delay” tag (XEP-0203)

      - reply_to (Optional[slidge.util.types.MessageReference]) – Quote another message (XEP-0461)

      - hints (Optional[Iterable[slidge.util.types.ProcessingHint]])

      - thread (Optional[slidge.util.types.LegacyThreadType])

      - carbon (bool) – (only in 1:1) Reflect a message sent to this `Contact` by the user. Use this to synchronize outgoing history for legacy official apps.

      - archive_only (bool) – (only in groups) Do not send this message to user, but store it in the archive. Meant to be used during `MUC.backfill()`

      - correction_event_id (Optional[slidge.util.types.LegacyMessageType]) – in the case where an ID is associated with the legacy ‘correction event’, specify it here to use it on the XMPP side. If not specified, a random ID will be used.

      - link_previews (Optional[list[slidge.util.types.LinkPreview]]) – A little of sender (or server, or gateway)-generated previews of URLs linked in the body.

    Return type:

      None

  react(legacy_msg_id, emojis=(), thread=None, **kwargs)

    Send a reaction (XEP-0444) from this XMPP Entity.

    Parameters:

      - legacy_msg_id (slidge.util.types.LegacyMessageType) – The message which the reaction refers to.

      - emojis (Iterable[str]) – An iterable of emojis used as reactions

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Return type:

      None

  retract(legacy_msg_id, thread=None, **kwargs)

    Send a message retraction (XEP-0424) from this XMPP Entity.

    Parameters:

      - legacy_msg_id (slidge.util.types.LegacyMessageType) – Legacy ID of the message to delete

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Return type:

      None